program serpent;

{ UNITES }

uses dos,crt,vbe2,vbe2ext;

{ CONSTANTES }

const
{Graphisme}                         {Fichier de sauvegarde du menu}
     RepBGI = 'D:\TP\BGI';             Fmenu  = 'serpent.gab';
     MaxX   = 640;
     MaxY   = 480;

{Options}
     CNbJMin    = 1;                   CVitesseMin    = 1;
     CNbJMax    = 4;                   CVitesseMax    = 9;
     CNbJDefaut = 2;                   CVitesseDefaut = 6;
     CNbJPas    = 1;                   CVitessePas    = 1;

     CEcranMin    = 0;                 CNbPartiesMin    = 5;
     CEcranMax    = 9;                 CNbPartiesMax    = 50;
     CEcranDefaut = 0;                 CNbPartiesDefaut = 10;
     CEcranPas    = 1;                 CNbPartiesPas    = 5;

{Caractres affichs}
     CCarFlecheHaut   = chr(24);       CCarGrosseFlecheHaut   = chr(30);
     CCarFlecheDroite = chr(26);       CCarGrosseFlecheDroite = chr(16);
     CCarFlecheBas    = chr(25);       CCarGrosseFlecheBas    = chr(31);
     CCarFlecheGauche = chr(27);       CCarGrosseFlecheGauche = chr(17);
     CCarTete         = chr(2);

{Couleurs}                          {Coord d'affichage du menu}
     CCoulMenuPassive = 15;{White}     CLargCadreMenu    = 450;
     CCoulMenuActive  = 14;{Yellow}    CHautCadreMenu    = 280;
     CCoulMenuTouches = 4; {Red}       CAbsTouches       = 10;
     CCoulFond        = 0; {Black}     CAbsTexte         = 60;
     CCouleurNeutre   = 15;{White}     CAbsDonnees       = 210;
     CCoulRemp        = 8; {DarkGray}  COrdNbJ           = 30;
                                       COrdVitesse       = 70;
{Touches du menu}                      COrdNbParties     = 110;
     CCarNul         = #0 ;            COrdEcran         = 150;
     CToucheNbJ      = #59;{F1}        COrdJouer         = 200;
     CToucheVitesse  = #60;{F2}        COrdToucheAide    = 230;
     CToucheNbParties= #61;{F3}        COrdQuitter       = 260;
     CToucheEcran    = #62;{F4}        CLargSaisieNum    = 14;
     CToucheJouer    = #67;{F9}        CHautSaisieNum    = 6;
     CToucheCurs1    = #63;{F5}        CAbsCurs          = 280; {Curseurs}
     CToucheCurs2    = #64;{F6}        CAbsTouchesCurs   = CAbsCurs-12;
     CToucheCurs3    = #65;{F7}        COrdCurs          = 10;
     CToucheCurs4    = #66;{F8}        CInterligneCurs   = 20;
     CToucheValider  = #13;{Entre}    CIntercolonneCurs = 30;
     CToucheQuitter  = #27;{Echap}     CAbsApercu        = 260;{Affichage depart}
     CToucheDecrem   = #75;{->}        COrdApercu        = 140;
     CToucheIncrem   = #77;{<-}        CLargApercu       = MaxX div 4;
     CToucheAide     = #68;{F10}       CHautApercu       = MaxY div 4;

{Coord d'affichage du rsultat}     {Temporel}
     CLargAffScore = 20;               CTpsDecompte    = 500;
     CHautResultat = 10;               CTpsDemarrage   = 100;
     CMargeAffRes  = 5;                CLenteurGlobale = 10;
     CAbsNumPartie = 2;                CPasVitesse     = 1;
     CAbsGagnant   = 20;               CPeriodeRepetitionTouche = 36{ms};
     CAbsScores    = 30;
     COrdAffRes    = 2;
     CPasResultat  = (MaxY-CHautResultat-2*CMargeAffRes) div (CNbJMax+1);

{Aide}
     CNbLignesAide = 29;
     CLargAide     = 560;
     CHautAide     = 10*CNbLignesAide;
     CAbsAide      = (MaxX-CLargAide)div 2;
     COrdAide      = (MaxY-CHautAide)div 2;
     CCoulFondAide = 8;{DarkGray}
     CTexteAide    = 1;{Blue}
     CAide : array [1..CNbLignesAide] of string =
('Utilisez les touches F1  F10 pour slectionner l''option de votre'  ,
'choix; celle-ci apparat en jaune. Utilisez les flches droite et'    ,
'gauche pour modifier la valeur. Enfin validez en appuyant sur Entre.',
'',
'La modification du nombre de joueurs (de 1  4) donne accs  leurs'  ,
'touches de curseur par les touches F5  F8. Il reste  appuyer sur'   ,
'les touches  utiliser dans l''ordre "Haut", "Droite", "Bas" et'      ,
'"Gauche". Si vous voulez faire une jolie figure symtrique, vous'     ,
'pouvez utiliser le mmes touches de curseurs pour plusieurs joueurs.' ,
'',
'Aprs validation d''un cran, celui-ci apparat en miniature dans le' ,
'cadre.',
'',
'Le but est d''esquiver les obstacles en blanc, la trace des autres'   ,
'joueurs ainsi que sa propre trace. Le dernier  russir gagne. A la'  ,
'fin de chaque partie, le numro de la partie est affich avec le'     ,
'gagnant (couleur de la tte) et le score de chaque joueur. Chaque'    ,
'joueur s''tant crash sur la couleur du gagnant lui concde 2 points,',
'sinon un seul point.',
'',
'A la fin de chaque partie, vous pouvez revenir au menu en appuyant'   ,
'sur la touche Echap'                                                  ,
'',
'Le jeu garde en mmoire la dernire configuration du menu dans'       ,
'le fichier "serpent.gab". Pour fonctionner, celui-ci doit tre pla',
'dans le mme rpertoire que cet xcutable et son nom ne doit pas'    ,
'tre modifi.'                                                        ,
'',
'Appuyez sur Entre pour revenir au menu.');

{ TYPES }

type
   Tdirection = (Haut,Droite,Bas,Gauche); {sens de dplacement}

   Tcurseur = array [Haut..Gauche] of char;

   Tjoueur = record
             abs,ord:word;         {position en pixels dans l'cran}
             curseur:Tcurseur;     {touches du clavier}
             coul:byte;            {couleur d'affichage}
             direction:Tdirection; {sens de dplacement}
             score:byte;           {points obtenus}
             coul_suiv:byte;       {Couleur du pixel o va aller le joueur}
             kapout:boolean;       {passe  vrai quand le joueur crash}
             end;

   TMenu = record
           NbJoueurs:byte;
           VitesseJeu:byte;
           NbParties:byte;
           Ecran:byte;
           end;

   TTabJ    = array [1..CNbJMax] of Tjoueur;
   TTabCurs = array [1..CNbJMax] of Tcurseur;
   TTabCoul = array [1..CNbJMax] of Integer;

const
{Joueurs par dfaut}
     CTabJ : TTabJ =
 ((abs:MaxX div 10;ord:MaxY div 2;curseur:(#122,#100,#115,#113);
   coul:1{Blue};direction:Droite;score:0;coul_suiv:CCoulFond;kapout:false),
  (abs:MaxX-MaxX div 10;ord:MaxY div 2;curseur:(#72,#77,#80,#75);
   coul:4{Red};direction:Gauche;score:0;coul_suiv:CCoulFond;kapout:false),
  (abs:MaxX div 2;ord:MaxY div 10;curseur:(#111,#109,#108,#107);
   coul:14{Yellow};direction:Bas;score:0;coul_suiv:CCoulFond;kapout:false),
  (abs:MaxX div 2;ord:MaxY-MaxY div 10;curseur:(#53,#57,#54,#51 );
   coul:2{Green};direction:Haut;score:0;coul_suiv:CCoulFond;kapout:false));


{En Azerty: (#122,#100,#115,#113) , (#72,#77,#80,#75) ,
            (#111,#109,#108,#107) , (#53,#57,#54,#51)}
{En Qwerty: (#119,#100,#115,#97 ) , (#72,#77,#80,#75) ,
            (#111,#59 ,#108,#107) , (#53,#57,#54,#51)}

{ VARIABLES }

var
   OldPattern:FillPatternType;
   Menu:TMenu;
   TabJ:TTabJ; {tableau des joueurs}
   NumPartie:byte;
   quitter:boolean;
   Largeur,Abscisse,Ordonnee:word;

{ PROCEDURES & FONCTIONS }

{****************************************************************************}
procedure AfficherCopyright;
const
     texte1 = '  Cr par GABOURIN Stphane, version 1.0  ';
     texte2 = '  Inspir par RODRIGUEZ RUIZ Miguel Angel  ';
begin
  SetTextStyle(DefaultFont,HorizDir,1);
  SetColor(CCoulMenuActive);
  outtextxy((MaxX-TextWidth(texte1))div 2,MaxY-80,CCarTete);
  outtextxy(484,MaxY-80,CCarTete);
  outtextxy((MaxX-TextWidth(texte1))div 2,MaxY-65,CCarTete);
  outtextxy(484,MaxY-65,CCarTete);
  SetColor(CCoulMenuActive);
  outtextxy((MaxX-TextWidth(texte1))div 2,MaxY-80,texte1);
  outtextxy((MaxX-TextWidth(texte2))div 2,MaxY-65,texte2);
  SetColor(LightBlue);
  OutTextxy(132,465,'Tlcharg sur http://stephane.gabourin.free.fr');
end;
{****************************************************************************}

{****************************************************************************}
function IntToStr(i:integer):string;
var
   s:string;
begin
   str(i,s);
   IntToStr:=s;
end;
{****************************************************************************}


{ GESTION DU MENU }

{****************************************************************************}
procedure Initialisations;
var
   DirInfo:SearchRec;
   F:Text;
   i:byte;
   d:Tdirection;
begin
   TabJ:=CTabJ;
   FindFirst(Fmenu,AnyFile,DirInfo);
   with Menu do
   begin
     if DosError=18 then
     begin
       NbJoueurs:=CNbJDefaut;
       VitesseJeu:=CVitesseDefaut;
       NbParties:=CNbPartiesDefaut;
       Ecran:=CEcranDefaut;
     end
   else begin
       Assign(F,Fmenu);
       Reset(F);
       Read(F,Menu.NbJoueurs);
       Read(F,Menu.VitesseJeu);
       Read(F,Menu.NbParties);
       Readln(F,Menu.Ecran);
       for i:=1 to Menu.NbJoueurs do
         for d:=Haut to Gauche do
           Read(F,TabJ[i].curseur[d]);
       Close(F);
     end;
   end; {of with}
   Randomize;
end;
{****************************************************************************}

{****************************************************************************}
procedure AfficherCurseurs;
var
   dir:Tdirection;
   i:integer;
begin
   setcolor(CCoulMenuPassive);
   SetFillPattern(OldPattern,CCoulFond);
   Bar (CAbsCurs, COrdCurs, CAbsCurs+(CNbJMax+1)*CIntercolonneCurs,
                            COrdCurs+(CNbJMax+2)*CInterligneCurs);
   outtextxy(CAbsCurs,COrdCurs+2*CInterligneCurs,CCarGrosseFlecheHaut);
   outtextxy(CAbsCurs,COrdCurs+3*CInterligneCurs,CCarGrosseFlecheDroite);
   outtextxy(CAbsCurs,COrdCurs+4*CInterligneCurs,CCarGrosseFlecheBas);
   outtextxy(CAbsCurs,COrdCurs+5*CInterligneCurs,CCarGrosseFlecheGauche);
   for i:=1 to Menu.NbJoueurs do
   begin
      setcolor(CCoulMenuTouches);
      outtextxy (CAbsCurs-12+CIntercolonneCurs*i,
                 COrdCurs,'[F'+IntToStr(i+4)+']');
      setcolor(TabJ[i].Coul);
      outtextxy(CAbsCurs+CIntercolonneCurs*i,
                COrdCurs+CInterligneCurs,CCarTete);
      setcolor(CCoulMenuPassive);
      for dir:=Haut to Gauche do
         case TabJ[i].curseur[dir] of
           'H': outtextxy(CAbsCurs+CIntercolonneCurs*i,
                          COrdCurs+CInterligneCurs*(ord(dir)+2),
                          CCarFlecheHaut);
           'M': outtextxy(CAbsCurs+CIntercolonneCurs*i,
                          COrdCurs+CInterligneCurs*(ord(dir)+2),
                          CCarFlecheDroite);
           'P': outtextxy(CAbsCurs+CIntercolonneCurs*i,
                          COrdCurs+CInterligneCurs*(ord(dir)+2),
                          CCarFlecheBas);
           'K': outtextxy(CAbsCurs+CIntercolonneCurs*i,
                          COrdCurs+CInterligneCurs*(ord(dir)+2),
                          CCarFlecheGauche);
           else outtextxy(CAbsCurs+CIntercolonneCurs*i,
                          COrdCurs+CInterligneCurs*(ord(dir)+2),
                          TabJ[i].curseur[dir]);
        end; {of case}
   end;
end;
{****************************************************************************}

{****************************************************************************}
procedure AfficherApercuEcran;
var
   i:byte;
   x,y,dx,dy:byte;
   pt:pointer;
begin
   SetViewPort((MaxX-CLargCadreMenu)div 2+CAbsApercu,
               (MaxY-CHautCadreMenu)div 2+COrdApercu,
               (MaxX-CLargCadreMenu)div 2+CAbsApercu+CLargApercu,
               (MaxY-CHautCadreMenu)div 2+COrdApercu+CHautApercu,True);
   SetFillPattern(OldPattern,CCoulFond);
   Bar(1,1,CLargApercu-1,CHautApercu-1);
   setcolor(CCoulMenuPassive);
   Rectangle (0,0,CLargApercu,CHautApercu);
   case Menu.Ecran of
      1:begin                                              {Ŀ}
        line( 35,30, 45,30);      line( 40, 26, 40, 34);   {         }
        line(115,30,125,30);      line( 40, 84, 40, 94);   {       }
        line(  0,60,  5,60);      line( 80,  0, 80,  4);   {         }
        line( 75,60, 85,60);      line( 80, 56, 80, 64);   {        }
        line(155,60,160,60);      line( 80,116, 80,120);   {         }
        line( 35,90, 45,90);      line(120, 26,120, 34);   {       }
        line(115,90,125,90);      line(120, 86,120, 94);   {         }
        end;                                               {}
      2:begin
        line(40, 15,55, 15);      line(105, 15,120, 15);   {Ŀ}
        line(40, 15,40, 30);      line(120, 15,120, 30);   {    Ŀ }
        line(25, 30,40, 30);      line(120, 30,135, 30);   {     }
        line(25, 30,25, 45);      line(135, 30,135, 45);   {       }
        line(65, 45,95, 75);      line( 65, 75, 95, 45);   {    X    }
        line(25, 75,25, 90);      line(135, 75,135, 90);   {       }
        line(25, 90,40, 90);      line(120, 90,135, 90);   {     ٳ}
        line(40, 90,40,105);      line(120, 90,120,105);   {     }
        line(40,105,55,105);      line(105,105,120,105);   {}
        end;
      3:begin                                              {Ŀ}
        line( 15, 20, 35,40);      line( 50,40, 70, 20);   {         }
        line( 90, 20,110,40);      line(125,40,145, 20);   { \ / \ / }
        line( 35, 40, 35,50);      line( 50,40, 50, 50);   {     }
        line(110, 40,110,50);      line(125,40,125, 50);   {         }
        line( 35, 70, 35,80);      line( 50,70, 50, 80);   {     }
        line(110, 70,110,80);      line(125,70,125, 80);   { / \ / \ }
        line( 15,100, 35,80);      line( 50,80, 70,100);   {         }
        line( 90,100,110,80);      line(125,80,145,100);   {}
        end;
      4:begin                                              {Ŀ}
        line(24,45,61,  7);         line(99,  7,136,45);   {   / \   }
        line(40,49,65, 24);         line(95, 24,120,49);   {  // \\  }
        line(56,52,69, 40);         line(91, 40,104,52);   { /// \\\ }
        line(24,75,61,112);         line(99,112,136,75);   {         }
        line(40,71,65, 96);         line(95, 96,120,71);   { \\\ /// }
        line(56,68,69, 80);         line(91, 80,104,68);   {  \\ //  }
        PutPixel(80,60,CCouleurNeutre);                    {   \ /   }
        end;                                               {}
      5:begin
        line(80, 0,80, 10);       line( 80,110, 80,120);   {Ŀ}
        line(60,20,60, 30);       line(100, 20,100, 30);   {        }
        line(40,30,60, 30);       line(100, 30,120, 30);   {  Ŀ }
        line(40,30,40, 50);       line(120, 30,120, 50);   { ٳ    }
        line(20,50,40, 50);       line(120, 50,140, 50);   {    }
        line(60,40,60, 80);       line(100, 40,100, 80);   {     }
        line( 0,60,12, 60);       line(148, 60,160, 60);   { Ŀ  }
        line(20,70,40, 70);       line(120, 70,140, 70);   {        }
        line(40,70,40, 90);       line(120, 70,120, 90);   {}
        line(40,90,60, 90);       line(100, 90,120, 90);
        line(60,90,60,100);       line(100, 90,100,100);
        line(70,60,90, 60);
        end;
      6:begin
        line( 30,  7, 50,  7);    line( 10, 22, 10, 37);   {Ŀ}
        line(110,  7,130,  7);    line( 10, 82, 10, 97);   {      }
        line(130, 37,150, 37);    line( 50,  7, 50, 22);   {      }
        line( 10, 37, 30, 37);    line( 50, 97, 50,112);   {      }
        line( 50, 52, 70, 52);    line( 70, 37, 70, 52);   {      }
        line( 90, 52,110, 52);    line( 70, 67, 70, 82);   {      }
        line( 50, 67, 70, 67);    line( 90, 37, 90, 52);   {      }
        line( 90, 67,110, 67);    line( 90, 67, 90, 82);   {}
        line( 10, 82, 30, 82);    line(110,  7,110, 22);
        line(130, 82,150, 82);    line(110, 97,110,112);
        line( 30,112, 50,112);    line(150, 22,150, 37);
        line(110,112,130,112);    line(150, 82,150, 97);
        end;
      7:begin
        line(30, 7,55, 7);        arc(30,27, 90,180,20);   {Ŀ}
        line(30,22,55,22);        arc(30,32,180,270,20);   {   Ŀ }
        line(30,37,55,37);        arc(55, 2,270,360,20);   {    }
        line(30,52,55,52);        arc(55,57,  0, 90,20);   {  Ŀ  }
                                                           {    }
        line(105, 7,130, 7);    arc(105,  2,180,270,20);   {   Ŀ }
        line(105,22,130,22);    arc(105, 57, 90,180,20);   {    }
        line(105,37,130,37);    arc(130, 27,  0, 90,20);   {  Ŀ  }
        line(105,52,130,52);    arc(130, 32,270,360,20);   {    }
                                                           {}
        GetMem(pt,ImageSize(0,0,560,220));
        GetImage(10,2,150,57,pt^);
        PutImage(10,62,pt^,NormalPut);
        end;
      8:begin
          SetFillPattern(OldPattern,CCoulRemp);            {       }
          SetColor(CCouleurNeutre);                        {  .     }
          for i:=1 to 10 do                                {       }
          begin                                            {    .  }
            x:=random(CLargApercu);                        {  . .   }
            y:=random(CHautApercu);                        {       }
            dx:=3+random(10);
            dy:=3+random(10);
            bar(x,y,x+dx,y+dy);
            rectangle(x,y,x+dx,y+dy);
          end;
        end;
      9:begin
          SetFillPattern(OldPattern,CCoulRemp);            {   o   o }
          SetColor(CCouleurNeutre);                        {  O   O  }
          for i:=1 to 10 do                                {    o    }
          begin                                            {    O  }
            x:=random(CLargApercu);                        {  O o   }
            y:=random(CHautApercu);
            dx:=3+random(5);
            dy:=3+random(5);
            fillellipse(x,y,dx,dy);
            ellipse(x,y,0,360,dx,dy);
          end;
        end;
   end; {of case}
   for i:=1 to Menu.NbJoueurs do
   begin
     SetColor(TabJ[i].coul);
     outtextxy(round(TabJ[i].abs*(CLargApercu/MaxX))-TextWidth(CCarTete) div 2,
               (TabJ[i].ord*CHautApercu) div MaxY - TextHeight(CCarTete) div 2,
               CCarTete);
   end;
   SetViewPort((MaxX-CLargCadreMenu)div 2,(MaxY-CHautCadreMenu)div 2,
                MaxX-(MaxX-CLargCadreMenu)div 2,
                MaxY-(MaxY-CHautCadreMenu)div 2,false);
end;
{****************************************************************************}

{****************************************************************************}
{affiche la page de menu}
procedure AfficherMenu;
const
     tabcoul:TColorsArray=(120,122,124,126);
begin
   ClearDevice;
   SetBkColor(CCoulFond);
   SetTextStyle(DefaultFont, HorizDir, 4);
   SetColor(Green);
   OutCoolTextxy((GetMaxX-TextWidth('Serpents'))div 2,40,'Serpents',tabcoul);
   SetTextStyle(DefaultFont, HorizDir, 1);
   AfficherCopyright;
   SetViewPort((MaxX-CLargCadreMenu)div 2,(MaxY-CHautCadreMenu)div 2,
                MaxX-(MaxX-CLargCadreMenu)div 2,
                MaxY-(MaxY-CHautCadreMenu)div 2,false);
   setcolor(CCoulMenuPassive);
   Rectangle(0,0,CLargCadreMenu,CHautCadreMenu);
   setcolor(CCoulMenuTouches);
   outtextxy(CAbsTouches,COrdNbJ,'[F1]');
   outtextxy(CAbsTouches,COrdVitesse,'[F2]');
   outtextxy(CAbsTouches,COrdNbParties,'[F3]');
   outtextxy(CAbsTouches,COrdEcran,'[F4]');
   outtextxy(CAbsTouches,COrdJouer,'[F9]');
   outtextxy(CAbsTouches,COrdToucheAide,'[F10]');
   outtextxy(CAbsTouches,COrdQuitter,'[Esc]');
   setcolor(CCoulMenuPassive);
   outtextxy(CAbsTexte,COrdNbJ,'Nb joueurs:');
   outtextxy(CAbsDonnees,COrdNbJ,IntToStr(Menu.NbJoueurs));
   outtextxy(CAbsTexte,COrdVitesse,'Vitesse du jeu:');
   outtextxy(CAbsDonnees,COrdVitesse,IntToStr(Menu.VitesseJeu));
   outtextxy(CAbsTexte,COrdNbParties,'Nombre de parties:');
   outtextxy(CAbsDonnees,COrdNbParties,IntToStr(Menu.NbParties));
   outtextxy(CAbsTexte,COrdEcran,'Ecran de jeu:');
   outtextxy(CAbsDonnees,COrdEcran,IntToStr(Menu.Ecran));
   outtextxy(CAbsTexte,COrdJouer,'Jouer');
   outtextxy(CAbsTexte,COrdToucheAide,'Aide');
   outtextxy(CAbsTexte,COrdQuitter,'Quitter');
   AfficherCurseurs;
   AfficherApercuEcran;
end;
{****************************************************************************}

{****************************************************************************}
{gre les choix numriques grs avec les flches du clavier}
procedure MenuFleches(var valeur:byte;x,y,min,max,pas:word);
var
   c:char;
begin
   SetColor(CCoulMenuActive);
   SetFillPattern(OldPattern,CCoulFond);
   outtextxy(x,y,IntToStr(valeur));
   repeat
      c:=readkey;
      if c=CCarNul then
      begin
         c:=readkey;
         case c of
            CToucheIncrem:if (valeur<=max-pas)
                             then inc(valeur,pas)
                             else valeur:=min;
            CToucheDecrem:if (valeur>=min+pas)
                             then dec(valeur,pas)
                             else valeur:=max;
         end;{of case}
         bar(x,y,x+CLargSaisieNum,y+CHautSaisieNum);
         outtextxy(x,y,IntToStr(valeur));
      end;
   until c=CToucheValider;
   SetColor(CCoulMenuPassive);
   outtextxy(x,y,IntToStr(valeur));
end;
{****************************************************************************}

{****************************************************************************}
{gre les choix de touches pour les curseurs}
procedure AffecterCurseur(NumJ:byte);
var
   c:char;
   dir:Tdirection;
begin
   SetFillPattern(OldPattern,CCoulFond);
   for dir:=Haut to Gauche do
   begin
      SetColor(CCoulMenuActive);
      case TabJ[NumJ].curseur[dir] of
         'H': outtextxy (CAbsCurs+CIntercolonneCurs*NumJ,
                         COrdCurs+CInterligneCurs*(ord(dir)+2),CCarFlecheHaut);
         'M': outtextxy (CAbsCurs+CIntercolonneCurs*NumJ,
                         COrdCurs+CInterligneCurs*(ord(dir)+2),CCarFlecheDroite);
         'P': outtextxy (CAbsCurs+CIntercolonneCurs*NumJ,
                         COrdCurs+CInterligneCurs*(ord(dir)+2),CCarFlecheBas);
         'K': outtextxy (CAbsCurs+CIntercolonneCurs*NumJ,
                         COrdCurs+CInterligneCurs*(ord(dir)+2),CCarFlecheGauche);
         else outtextxy (CAbsCurs+CIntercolonneCurs*NumJ,
                         COrdCurs+CInterligneCurs*(ord(dir)+2),
                         TabJ[NumJ].curseur[dir]);
      end; {of case}
      c:=readkey;
      if c=CCarNul then c:=readkey;
      TabJ[NumJ].curseur[dir]:=c;
      AfficherCurseurs;
   end;
end;
{****************************************************************************}

{****************************************************************************}
procedure AfficherAide;
var
   c:char;
   i:byte;
begin
   SetViewPort(CAbsAide,COrdAide,CAbsAide+CLargAide,COrdAide+CHautAide,True);
   SetFillPattern(OldPattern,CCoulFondAide);
   SetColor(CTexteAide);
   bar(0,0,CLargAide,CHautAide);
   for i:=1 to CNbLignesAide do
   begin
     OutTextXY(5,10*i,CAide[i]);
   end;
   repeat c:=readkey; until c=CToucheValider;
   SetViewPort(0, 0, GetMaxX, GetMaxY, True);
   AfficherMenu;
end;
{****************************************************************************}

{****************************************************************************}
{procedure gnrale de gestion du menu}
procedure MenuPrincipal(var quitter:boolean);
var
   i:integer;
   c:char;
begin
   NumPartie:=1;
   AfficherMenu;
   for i:=1 to CNbJMax do TabJ[i].score:=CTabJ[i].score;
   repeat
     c:=readkey;
     if c=CCarNul then
     begin
       c:=readkey;
       case c of
         CToucheNbJ : begin
                      MenuFleches (Menu.NbJoueurs,CAbsDonnees,COrdNbJ,
                                   CNbJMin,CNbJMax,CNbJPas);
                      AfficherCurseurs;
                      AfficherApercuEcran;
                      end;
         CToucheVitesse : MenuFleches(Menu.VitesseJeu,CAbsDonnees,
                                      COrdVitesse,CVitesseMin,CVitesseMax,
                                      CVitessePas);
         CToucheNbParties : MenuFleches(Menu.NbParties,CAbsDonnees,
                                        COrdNbParties,CNbPartiesMin,
                                        CNbPartiesMax,CNbPartiesPas);
         CToucheEcran  :begin
                        MenuFleches (Menu.Ecran,CAbsDonnees,COrdEcran,
                                     CEcranMin,CEcranMax,CEcranPas);
                        AfficherApercuEcran;
                        end;
         CToucheCurs1 : AffecterCurseur(1);
         CToucheCurs2 : if Menu.NbJoueurs>1 then AffecterCurseur(2);
         CToucheCurs3 : if Menu.NbJoueurs>2 then AffecterCurseur(3);
         CToucheCurs4 : if Menu.NbJoueurs>3 then AffecterCurseur(4);
         CToucheAide : AfficherAide;
       end;{of case}
     end;
   until (c=CToucheJouer) or (c=CToucheQuitter);
   quitter:=(c=CToucheQuitter);
   SetViewPort(0,0,GetMaxX,GetMaxY,true);
end;
{****************************************************************************}


{ GESTION DU JEU }

{****************************************************************************}
procedure ReinitialiserLesJoueurs;
var
   i:integer;
begin
   for i:=1 to CNbJMax do
   begin
      TabJ[i].abs:=CTabJ[i].abs;
      TabJ[i].ord:=CTabJ[i].ord;
      TabJ[i].direction:=CTabJ[i].direction;
      TabJ[i].coul_suiv:=CTabJ[i].coul_suiv;
      TabJ[i].kapout:=CTabJ[i].kapout;
   end;
end;
{****************************************************************************}

{****************************************************************************}
procedure DessinerEcran;
const
   rayon=80;
var
   i:byte;
   pt:pointer;
   x,y,dx,dy:word;
begin
   SetColor(CCouleurNeutre);
   if Menu.Ecran<6 then Rectangle(0,0,GetMaxX-1,GetMaxY-1);
   if Menu.Ecran>0 then
   begin
      SetColor(CCoulFond);
      line(0,220,0,260);
      line(GetMaxX-1,220,GetMaxX-1,260);
      line(300,0,340,0);
      line(300,GetMaxY-1,340,GetMaxY-1);
   end;
   SetColor(CCouleurNeutre);
   SetFillPattern(OldPattern,CCouleurNeutre);
   case Menu.Ecran of
      1:begin                                                 {Ŀ}
        line(140,120,180,120);       line(160,105,160,135);   {         }
        line(460,120,500,120);       line(160,345,160,375);   {       }
        line(  0,240, 20,240);       line(320,  0,320, 15);   {         }
        line(300,240,340,240);       line(320,225,320,255);   {        }
        line(620,240,640,240);       line(320,465,320,480);   {         }
        line(140,360,180,360);       line(480,105,480,135);   {       }
        line(460,360,500,360);       line(480,345,480,375);   {         }
        end;                                                  {}
      2:begin
        line(160, 60,220, 60);       line(420, 60,480, 60);   {Ŀ}
        line(160, 60,160,120);       line(480, 60,480,120);   {    Ŀ }
        line(100,120,160,120);       line(480,120,540,120);   {     }
        line(100,120,100,180);       line(540,120,540,180);   {       }
        line(260,180,380,300);       line(260,300,380,180);   {    X    }
        line(100,300,100,360);       line(540,300,540,360);   {       }
        line(100,360,160,360);       line(480,360,540,360);   {     ٳ}
        line(160,360,160,420);       line(480,360,480,420);   {     }
        line(160,420,220,420);       line(420,420,480,420);   {}
        end;
      3:begin                                                 {Ŀ}
        line( 60, 80,140,160);       line(200,160,280, 80);   {         }
        line(360, 80,440,160);       line(500,160,580, 80);   { \ / \ / }
        line(140,160,140,200);       line(200,160,200,200);   {     }
        line(440,160,440,200);       line(500,160,500,200);   {         }
        line(140,280,140,320);       line(200,280,200,320);   {     }
        line(440,280,440,320);       line(500,280,500,320);   { / \ / \ }
        line( 60,400,140,320);       line(200,320,280,400);   {         }
        line(360,400,440,320);       line(500,320,580,400);   {}
        end;
      4:begin                                                 {Ŀ}
        line( 95,180,245, 30);       line(395, 30,545,180);   {   / \   }
        line(160,195,260, 95);       line(380, 95,480,195);   {  // \\  }
        line(225,210,275,160);       line(365,160,415,210);   { /// \\\ }
        line( 95,300,245,450);       line(395,450,545,300);   {         }
        line(160,285,260,385);       line(380,385,480,285);   { \\\ /// }
        line(225,270,275,320);       line(365,320,415,270);   {  \\ //  }
        PutPixel(320,240,CCouleurNeutre);                     {   \ /   }
        end;                                                  {}
      5:begin
        line(320,  0,320, 40);       line(320,440,320,480);   {Ŀ}
        line(240, 80,240,120);       line(400, 80,400,120);   {        }
        line(160,120,240,120);       line(400,120,480,120);   {  Ŀ }
        line(160,120,160,200);       line(480,120,480,200);   { ٳ    }
        line( 80,200,160,200);       line(480,200,560,200);   {    }
        line(240,160,240,320);       line(400,160,400,320);   {     }
        line(  0,240, 50,240);       line(590,240,640,240);   { Ŀ  }
        line( 80,280,160,280);       line(480,280,560,280);   {        }
        line(160,280,160,360);       line(480,280,480,360);   {}
        line(160,360,240,360);       line(400,360,480,360);
        line(240,360,240,400);       line(400,360,400,400);
        line(280,240,360,240);
        end;
      6:begin
        line(120, 30,200, 30);       line( 40, 90, 40,150);   {Ŀ}
        line(440, 30,520, 30);       line( 40,330, 40,390);   {      }
        line(520,150,600,150);       line(200, 30,200, 90);   {      }
        line( 40,150,120,150);       line(200,390,200,450);   {      }
        line(200,210,280,210);       line(280,150,280,210);   {      }
        line(360,210,440,210);       line(280,270,280,330);   {      }
        line(200,270,280,270);       line(360,150,360,210);   {      }
        line(360,270,440,270);       line(360,270,360,330);   {}
        line( 40,330,120,330);       line(440, 30,440, 90);
        line(520,330,600,330);       line(440,390,440,450);
        line(120,450,200,450);       line(600, 90,600,150);
        line(440,450,520,450);       line(600,330,600,390);
        end;
      7:begin
        line(120, 30,220, 30);  arc(120,110, 90,180,rayon);   {Ŀ}
        line(120, 90,220, 90);  arc(120,130,180,270,rayon);   {   Ŀ }
        line(120,150,220,150);  arc(220, 10,270,360,rayon);   {    }
        line(120,210,220,210);  arc(220,230,  0, 90,rayon);   {  Ŀ  }
                                                              {    }
        line(420, 30,520, 30);  arc(420, 10,180,270,rayon);   {   Ŀ }
        line(420, 90,520, 90);  arc(420,230, 90,180,rayon);   {    }
        line(420,150,520,150);  arc(520,110,  0, 90,rayon);   {  Ŀ  }
        line(420,210,520,210);  arc(520,130,270,360,rayon);   {    }
                                                              {}
        GetMem(pt,ImageSize(0,0,560,220));
        GetImage(40,10,600,230,pt^);
        PutImage(40,250,pt^,NormalPut);
        end;
      8:begin
        SetFillPattern(OldPattern,CCoulRemp);                 {       }
        SetColor(CCouleurNeutre);                             {  .     }
        for i:=1 to 40 do                                     {       }
          begin                                               {    .  }
            x:=random(GetMaxX);                               {  . .   }
            y:=random(GetMaxY);                               {       }
            dx:=3+random(40);
            dy:=3+random(40);
            bar(x,y,x+dx,y+dy);
            rectangle(x,y,x+dx,y+dy);
          end;
        SetColor(CCoulFond);
        SetLineStyle(SolidLn,0,ThickWidth);
        line(TabJ[1].abs,TabJ[1].ord,TabJ[2].abs,TabJ[2].ord);
        if Menu.NbJoueurs>2 then
          line(TabJ[3].abs,TabJ[3].ord,TabJ[4].abs,TabJ[4].ord);
        SetLineStyle(SolidLn,0,NormWidth);
        end;
      9:begin
        SetFillPattern(OldPattern,CCoulRemp);                 {   o   o }
        SetColor(CCouleurNeutre);                             {  O   O  }
        for i:=1 to 40 do                                     {    o    }
          begin                                               {    O  }
            x:=random(GetMaxX);                               {  O o   }
            y:=random(GetMaxY);
            dx:=3+random(20);
            dy:=3+random(20);
            fillellipse(x,y,dx,dy);
            ellipse(x,y,0,360,dx,dy);
          end;
        SetColor(CCoulFond);
        SetLineStyle(SolidLn,0,ThickWidth);
        line(TabJ[1].abs,TabJ[1].ord,TabJ[2].abs,TabJ[2].ord);
        if Menu.NbJoueurs>2 then
          line(TabJ[3].abs,TabJ[3].ord,TabJ[4].abs,TabJ[4].ord);
        SetLineStyle(SolidLn,0,NormWidth);
        end;
   end; {of case}
end;
{****************************************************************************}

{****************************************************************************}
procedure LancerLeJeu;
var
   i:integer;
   s:string;
   touche:char;
begin
   ClearDevice;
   Setcolor(CCouleurNeutre);
   for i:=3 downto 1 do
   begin
     SetTextStyle(DefaultFont, HorizDir, 4-i);
     outtextxy ((MaxX-TextWidth(IntToStr(i)))div 2,
               (MaxY-TextHeight(IntToStr(i)))div 2,IntToStr(i));
     delay(CTpsDecompte);
     ClearDevice;
   end;
   SetTextStyle(DefaultFont, HorizDir, 1);
   DessinerEcran;
   delay(CTpsDemarrage);
   while keypressed do readkey;
end;
{****************************************************************************}

{****************************************************************************}
function PredDir(dir:Tdirection):Tdirection;
begin
   if dir=Haut then PredDir:=Gauche else PredDir:=Pred(dir);
end;
{****************************************************************************}

{****************************************************************************}
function SuccDir(dir:Tdirection):Tdirection;
begin
   if dir=Gauche then SuccDir:=Haut else SuccDir:=Succ(dir);
end;
{****************************************************************************}

{****************************************************************************}
function PlusAssezDeJoueurs:boolean;
var
   i,NbPasKapout:integer;
begin
   NbPasKapout:=0;
   for i:=1 to Menu.NbJoueurs do
       if not TabJ[i].kapout then inc(NbPasKapout);
   if Menu.NbJoueurs=1 then PlusAssezDeJoueurs:=(NbPasKapout=0)
                       else PlusAssezDeJoueurs:=(NbPasKapout<2);
end;
{****************************************************************************}

{****************************************************************************}
procedure AvancerLesJoueurs;
var
   NbJ,NbJ2:byte;
   lent:word;
   c:char;
   dir:Tdirection;
begin
  repeat
    for lent:=1 to CLenteurGlobale-CPasVitesse*Menu.VitesseJeu do {dfaut=4}
    begin
    {gestion du clavier}
      if keypressed then
      begin
        c:=readkey;
        if c=CCarNul then c:=readkey;
        for NbJ:=1 to Menu.NbJoueurs do
           if not TabJ[NbJ].kapout then
           begin
             if (c=TabJ[NbJ].curseur[PredDir(TabJ[NbJ].direction)])
              then TabJ[NbJ].direction:=PredDir(TabJ[NbJ].direction);
             if (c=TabJ[NbJ].curseur[SuccDir(TabJ[NbJ].direction)])
              then TabJ[NbJ].direction:=SuccDir(TabJ[NbJ].direction);
           end;
      end;
    {pause}
      delay(CPeriodeRepetitionTouche div (2*CNbJMax));
    end;
{gestion du deplacement}
    for NbJ:=1 to Menu.NbJoueurs do
      if not TabJ[NbJ].kapout then
      begin
        case TabJ[NbJ].direction of
          Haut   : TabJ[NbJ].ord:=(GetMaxY+TabJ[NbJ].ord-1) mod GetMaxY;
          Droite : TabJ[NbJ].abs:=(GetMaxX+TabJ[NbJ].abs+1) mod GetMaxX;
          Bas    : TabJ[NbJ].ord:=(GetMaxY+TabJ[NbJ].ord+1) mod GetMaxY;
          Gauche : TabJ[NbJ].abs:=(GetMaxX+TabJ[NbJ].abs-1) mod GetMaxX;
        end; {of case}
        TabJ[NbJ].coul_suiv := GetPixel(TabJ[NbJ].abs,TabJ[NbJ].ord);
        TabJ[NbJ].kapout:=(TabJ[NbJ].coul_suiv<>CCoulFond);{simple crash ??}
      end;
{double crash ??}
    for NbJ :=1 to (Menu.NbJoueurs-1) do
      for NbJ2:=(NbJ+1) to Menu.NbJoueurs do
        if (TabJ[NbJ].abs=TabJ[NbJ2].abs) and (TabJ[NbJ].ord=TabJ[NbJ2].ord)
        then begin
             TabJ[NbJ].kapout:=true;
             TabJ[NbJ2].kapout:=true;
             end;
{gestion de l'affichage}
    for NbJ:=1 to Menu.NbJoueurs do  {gestion de l'affichage}
      if not TabJ[NbJ].kapout then
       PutPixel(TabJ[NbJ].abs,TabJ[NbJ].ord,TabJ[NbJ].coul);
  until PlusAssezDeJoueurs;
end;
{****************************************************************************}

{****************************************************************************}
procedure GestionDuResultat(var quitter:boolean);
var
   i,gagnant:byte;
   c:char;
   Trouve:boolean;
begin
   if Menu.NbJoueurs=1 then
   begin
      SetColor(CCouleurNeutre);
      SetTextStyle(DefaultFont, HorizDir, 2);
      outtextxy ((GetMaxX-TextWidth (IntToStr(NumPartie)))div 2,
                 (GetMaxY-TextHeight(IntToStr(NumPartie)))div 2,
                  IntToStr(NumPartie));
      SetTextStyle(DefaultFont, HorizDir, 1);
   end else
   begin
{Calcul des dimensions Largeur, Abscisse et Ordonne}
      Largeur:=CAbsScores+Menu.NbJoueurs*CLargAffScore;
      Abscisse:=(GetMaxX-Largeur)div 2;
      Ordonnee:=CMargeAffRes;
      repeat
         Trouve:=true;
         for i:=1 to Menu.NbJoueurs do
            Trouve:= (Trouve) and
                     ((TabJ[i].abs<Abscisse-CMargeAffRes) or
                      (TabJ[i].abs>Abscisse+Largeur+CMargeAffRes) or
                      (TabJ[i].ord<Ordonnee-CMargeAffRes) or
                      (TabJ[i].ord>Ordonnee+CHautResultat+CMargeAffRes));
         if not Trouve then inc(Ordonnee,CPasResultat);
      until Trouve;
{Rcupration de la couleur du gagnant et calcul des scores}
      gagnant:=0;
      for i:=1 to Menu.NbJoueurs do if not TabJ[i].kapout then gagnant:=i;
      if gagnant>0 then {si y'a un gagnant}
      begin
         for i:=1 to Menu.NbJoueurs do    {on augmente son score}
            if TabJ[i].kapout
            then if (TabJ[i].coul_suiv = TabJ[gagnant].coul)
                 then inc(TabJ[gagnant].score,2)
                 else inc(TabJ[gagnant].score,1);
      end;
{Affichage}
      SetViewPort(Abscisse,Ordonnee,Abscisse+Largeur,Ordonnee+CHautResultat,true);
      ClearViewPort;
      SetColor(CCouleurNeutre);
      Rectangle(0,0,Largeur,CHautResultat);
      SetFillPattern(OldPattern,CCouleurNeutre);
      Bar(CAbsGagnant-1,0,Largeur,CHautResultat);
      outtextxy(2,2,IntToStr(NumPartie)); {Numro de la partie}
      if gagnant>0 then                   {Tete du vainqueur}
      begin
         SetColor(TabJ[gagnant].coul);
         outtextxy(CAbsGagnant,2,CCarTete);
      end;
      for i:=1 to Menu.NbJoueurs do       {Scores}
      begin
         SetColor(TabJ[i].coul);
         outtextxy(CAbsScores+(i-1)*CLargAffScore,2,IntToStr(TabJ[i].score));
      end;
   end;
   inc(NumPartie);{une partie de plus}
   repeat c:=readkey; until (c=CToucheValider)or(c=CToucheQuitter); {sortie}
   quitter:=(c=CToucheQuitter);
   SetViewPort(0,0,GetMaxX,GetMaxY,true);
end;
{****************************************************************************}

{****************************************************************************}
procedure SauverParametres;
var
   F:Text;
   DirInfo: SearchRec;
   i:byte;
begin
   FindFirst(Fmenu, Anyfile, DirInfo);
   Assign(F,Fmenu);
   Rewrite(F);
   Writeln(F,Menu.NbJoueurs);
   Writeln(F,Menu.VitesseJeu);
   Writeln(F,Menu.NbParties);
   Writeln(F,Menu.Ecran);
   for i:=1 to Menu.NbJoueurs do Write(F,TabJ[i].curseur);
   Close(F);
end;
{****************************************************************************}

{ PROGRAMME PRINCIPAL }


{****************************************************************************}
BEGIN
   initgraph(MaxX,MaxY,8,RepBGI);
   Initialisations;
   MenuPrincipal(quitter);
   while not quitter do
   begin
      while (NumPartie<=Menu.NbParties) and (not quitter) do
      begin
         LancerLeJeu;
         AvancerLesJoueurs;
         GestionDuResultat(quitter);
         ReinitialiserLesJoueurs;
      end;
      MenuPrincipal(quitter);
   end;
   SauverParametres;
   Closegraph;
END.
{****************************************************************************}
